
var userLang;

var app = {
    // Application Constructor
    initialize: function() {
        this.bindEvents();
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
        document.addEventListener('load', this.onDeviceLoad, false);
        document.addEventListener("resume", this.onResume, false);       
    },
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicitly call 'app.receivedEvent(...);'
    onDeviceReady: function() {
       	// device ready
        app.receivedEvent('deviceready');       	
    },
    // load Event Handler
    onLoad: function() {
    	FastClick.attach(document.body);
    },
    onResume: function () {
    	//alert('resume app');
    	app.loadRecipe();
    },
    // Update DOM on a Received Event
    receivedEvent: function(id) {
    	//console.log('Received Event: ' + id);
    	
    	//// LOAD
    	
    	// language
    	navigator.globalization.getPreferredLanguage(
    	  function (language) {
    		  //console.log('language: ' + language.value + '\n');
    		  userLang = language.value;
    		  app.loadRecipe();
    	  },
    	  function () {
    		  //console.log('Error getting language\n');
    		  app.loadRecipe();
    		  userLang = 'en-GB';
    	  }
    	);

    },
    loadRecipe: function () {
    	//alert('get current recipe');
    	
    	// current date for header
    	var fullDate = new Date();
       	var twoDigitMonth = fullDate.getMonth()+1;if(twoDigitMonth.length==1) twoDigitMonth="0" +twoDigitMonth+1;
       	var twoDigitDate = fullDate.getDate()+"";if(twoDigitDate.length==1)	twoDigitDate="0" +twoDigitDate;
       	var currentDate = twoDigitDate + "." + twoDigitMonth + "." + fullDate.getFullYear();
       	$('#date').html(currentDate);

       	// change Logo for DE
       	if(userLang == 'de-DE' || userLang == 'de-AT' || userLang == 'de-CH') {
       		var src = $('#logo img').attr("src").replace("en_600x200.png", "600x200.png");
       		$('#logo img').attr("src", src);
       	}
   	
    	var uri = 'http://app.one-smoothie-a-day.com/';
    	if(userLang == 'de-DE' || userLang == 'de-AT' || userLang == 'de-CH') {
    		uri = 'http://app.ein-smoothie-am-tag.de/';
    	}
    	
    	// get json
    	$.getJSON(uri+'smoothie.php?' + new Date().getTime(), function(data) {
    		//console.log(data);
    		// set language
    		if(userLang == 'de-DE' || userLang == 'de-AT' || userLang == 'de-CH') {
    			$('#ingreBox h2').html("Zutaten");
    			$('#decoBox h2').html("Zum Dekorieren");
    			$('#prepBox h2').html("Zubereitung");
    			if(data.credit != '') $('#creditLabel').html("Bildnachweis:");
    		}
    		
    		// set recipe
    		$('#title').html(data.title);
    		$('#picture').attr("src", uri + data.picture);
    		$('#picture').attr("alt", data.title);
    		$('#ingredients').html(data.ingredients);
    		$('#preparation').html(data.preparation);
    		$('#decoration').html(data.decoration);
    		$('#credit').html(data.credit);
    		
    		// unset existing timer
    		if(typeof myTimer !== "undefined") window.clearInterval(myTimer);
    	})
    	.fail(function() {
    		// console.log( "error" );
    		// restart after 10 seconds
    		var myTimer = setInterval(app.loadRecipe(), 10000);
    	});
    }
};